<script setup lang="ts">
    import { onErrorCaptured, ref } from 'vue'
    import { SilabColor } from '@/plugins/vuetify'
    import { SilabError } from '@/shared/errors/SilabError'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { isDefined } from './shared/helpers/types'

    const displaySnackbar = ref<boolean>(false)
    const snackBarMessage = ref<string>('')
    const snackBarColor = ref<string | undefined>()
    const nbRequestsLoading = ref<number>(0)

    let snackbarTimeout: number | undefined = undefined
    function displaySnackBarMessage(
        message: string,
        color?: keyof typeof SilabColor
    ) {
        snackBarMessage.value = message
        snackBarColor.value = color
        displaySnackbar.value = true
        if (isDefined(snackbarTimeout)) {
            window.clearTimeout(snackbarTimeout)
        }
        snackbarTimeout = window.setTimeout(() => {
            displaySnackbar.value = false
        }, 5000)
    }

    document.addEventListener('snackBarToDisplay', (e) => {
        const { message, color } = (<CustomEvent>e).detail
        displaySnackBarMessage(message, color)
    })

    document.addEventListener('loadingStarted', () => {
        nbRequestsLoading.value++
    })

    document.addEventListener('loadingEnded', () => {
        nbRequestsLoading.value--
    })

    function prettyfyError(error: SilabError) {
        let prettyMessage = error.message

        if (
            isDefined(
                (error.cause as { message: unknown } | undefined)?.message
            )
        ) {
            return `${prettyMessage} : ${String((error.cause as { message: unknown }).message)}`
        }

        if (
            isDefined(
                (error.cause as { message: unknown } | undefined)?.message
            )
        ) {
            return `${prettyMessage} : ${String(error.cause)}`
        }

        return prettyMessage
    }

    // DEBUT Gestion des erreurs imprévues ---------
    onErrorCaptured((error) => {
        if (error instanceof SilabError) {
            console.error(error)
            emitSnackBar(prettyfyError(error), 'error')
            return false
        }
    })
    // Note : les erreur qui sont lancées dans des fonciton asynchrones ne
    // sont pas interceptées par le `onErrorCaptured` de vue, on ajoute ça en complément
    window.addEventListener('unhandledrejection', (event) => {
        const error = event.reason
        if (error instanceof SilabError) {
            console.error(error)
            emitSnackBar(prettyfyError(error), 'error')
        }
    })
    // FIN Gestion des erreurs imprévues -----------
</script>

<template>
    <v-app>
        <router-view></router-view>
        <v-snackbar
            v-model="displaySnackbar"
            data-cy="snackbar"
            :timeout="-1"
            :color="snackBarColor"
        >
            {{ snackBarMessage }}
            <template #actions>
                <v-btn
                    data-cy="snackbar-button"
                    type="text"
                    :color="snackBarColor ? `on-${snackBarColor}` : undefined"
                    @click="displaySnackbar = false"
                >
                    Fermer
                </v-btn>
            </template>
        </v-snackbar>
    </v-app>
</template>
<style scoped>
    @media print {
        /* vuetify réserve de la place pour la navbar même si celle-ci est cachée,
        il faut retirer cet espace pour le print : https://stackoverflow.com/a/50772473/2474460 */
        .v-main {
            padding-top: initial;
        }
    }
</style>
